<?php

namespace Ems\Controllers;

use Doctrine\ORM\EntityManager;

use Exception\Messages;
use Service\LogService;
use Service\OAuth\OAuthCustomImpl;
use Zeedhi\Framework\Controller\Simple;
use Zeedhi\Framework\HTTP\Kernel;
use Zeedhi\Framework\DTO\Request;
use Zeedhi\Framework\DTO\Response;
use Zeedhi\Framework\DataSource\DataSet;
use Zeedhi\Framework\DTO\Response\Error;
use Zeedhi\Framework\DTO\Response\Message;
use Zeedhi\Framework\DTO;

use Ems\Services\SituacaoFuncionalService;

class SituacaoFuncionalController {

    public function __construct(
        SituacaoFuncionalService $situacaoFuncionalService
    ) {
        $this->situacaoFuncionalService = $situacaoFuncionalService;
    }
    
    public function getUltimaSituacaoFuncional(
        Request\Row $request,
        Response    $response
    ) {
        try {
            $row = $request->getRow();

            $nrVinculom             = (int) $row['NRVINCULOM'];
            $nrperiodoapuracacao    = (int) $row['NRPERIODOAPURACACAO'];

            $ultimaSituacaoFuncional = $this->situacaoFuncionalService->
                retornaUltimaSituacaoFuncional($nrVinculom, $nrperiodoapuracacao);

            $response->addDataSet(new DataSet('getUltimaSituacaoFuncional', $ultimaSituacaoFuncional));
        } catch (\Exception $e) {
            $response->setError(new Error($e->getMessage(), $e->getCode(), $e->getTrace()));
        }
    }
    
    public function getPeriodosEstabilidade(
        Request\Row $request,
        Response    $response
    ) {
        try {
            $row = $request->getRow();

            $nrVinculom = (int) $row['NRVINCULOM'];

            $periodosEstabilidade = $this->situacaoFuncionalService->
                retornaPeriodosEstabilidade($nrVinculom);

            $response->addDataSet(new DataSet('getPeriodosEstabilidade', $periodosEstabilidade));
        } catch (\Exception $e) {
            $response->setError(new Error($e->getMessage(), $e->getCode(), $e->getTrace()));
        }
    }
    
}
