<?php
namespace Ems\Repository;

use Doctrine\ORM\EntityManager;
use Doctrine\DBAL\Connection;

class OperadorRepository {

    /** @var Connection */
    protected $connection;

    public function __construct(
        EntityManager $entityManager
    ) {
        $this->connection = $entityManager->getConnection();
    }

    public function getPerfisDeAcesso(array $params): array {
        $sql = <<<SQL
            SELECT PERFPARC.NRPERFILACESSO
            FROM PERFACESSPARC PERFPARC
            WHERE PERFPARC.NRPARCNEGOCIO = (
                SELECT OPER.NRPARCNEGOCIO
                FROM OPERADOR OPER
                WHERE OPER.CDOPERADOR = :P_CDOPERADOR
                  AND OPER.NRORG = PERFPARC.NRORG
            )
              AND PERFPARC.NRORG = :P_NRORG
SQL;

        $std = $this->connection->prepare($sql);
        $std->execute($params);
        $perfis = $std->fetchAll();

        return $perfis;
    }
    
    public function getOperadoresDp($nrorg) {
        $sql = "
               SELECT OP.* FROM OPERADOR OP
        JOIN PERFACESSPARC PA 
            ON OP.NRORG = PA.NRORG
            AND OP.NRPARCNEGOCIO = PA.NRPARCNEGOCIO
        WHERE OP.NRORG = :P_NRORG 
            AND NRPERFILACESSO IN (SELECT NRPERFACESSADM
              FROM GPE_PARAMORG 
             WHERE NRORG = :P_NRORG)
      ";

      $resultado = $this->connection->fetchAll($sql, array(
          "P_NRORG" => $nrorg
      ));
      
      return $resultado;
    }
}