/******************************************************************************/
/******************************************************************************/
/*                                                                            */
/* Trigger: DTULTATU_ALMX                                                     */
/* Tabela : ALMOXARIFADO                                                      */
/*                                                                            */
/* Criao:                                                                   */
/* 04/05/2004 - David Moreno Ferreira                                         */
/*                                                                            */
/******************************************************************************/

IF EXISTS(SELECT * FROM sysobjects O, sysusers U
          WHERE
            o.name = 'DTULTATU_ALMX'  and
            type = 'TR'               and
            u.uid = o.uid             and
            u.name = USER)
   DROP TRIGGER DTULTATU_ALMX
GO

CREATE TRIGGER DTULTATU_ALMX
ON ALMOXARIFADO
FOR INSERT, UPDATE, DELETE
AS
BEGIN
   IF (0 = (SELECT COUNT(*) FROM INSERTED)) BEGIN
      INSERT INTO DELETECACHE (NMTABLECACHE, CDFILICACHE, DSKEYCACHE, DTULTATUCACH)
			      (SELECT 'ALMOXARIFADO', CDFILIAL, 'CDFILIAL=' + CDFILIAL + ';' +
                                                 'CDALMOXARIFE=' + CDALMOXARIFE + ';', GETDATE() FROM DELETED)
   END
   ELSE BEGIN
      UPDATE ALMOXARIFADO
      SET DTULTATUALMX = GETDATE()
      FROM INSERTED
      WHERE (ISNULL(ALMOXARIFADO.CDALMOXARIFE,0) = ISNULL(INSERTED.CDALMOXARIFE,0)) AND
            (ISNULL(ALMOXARIFADO.DSALMOXARIFE,0) = ISNULL(INSERTED.DSALMOXARIFE,0)) AND
            (ISNULL(ALMOXARIFADO.CDFILIAL,0)     = ISNULL(INSERTED.CDFILIAL,0));
   END;
END;
GO

